/*
 *	queue.c
 * Copyright (c) 2001
 * 	Koh-ichi Ito All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the developer nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
#include <stdlib.h>
#include <string.h>

struct cell {
	char	*value;
	struct cell	*next;
};

static struct cell	*Queue = NULL;
static char	Id[] = "$Id: queue.c,v 1.1.1.1 2003/09/09 02:12:37 kohi Exp $";

char *enqueue(value)

	char	*value;
{
	struct cell	*p,
			*newcell;

	if (!(newcell = malloc(sizeof(struct cell) ) ) ) {
		return NULL;
	}
	if (!(newcell->value = strdup(value) ) ) {
		return NULL;
	}
	newcell->next = NULL;
	if (Queue == NULL) {
		Queue = newcell;
	} else {
		p = Queue;
		while (p->next) {
			p = p->next;
		}
		p->next = newcell;
	}
	return p->value;
}

char *dequeue()
{
	struct cell	*dispose;
	char	*value;

	if (Queue == NULL) {
		return NULL;
	}
	value = Queue->value;
	dispose = Queue;
	Queue = Queue->next;
	free(dispose);
	return value;
}

char *topqueue()
{
	if (Queue == NULL) {
		return NULL;
	}
	return Queue->value;
}
